OGRE: Ogre::GpuProgramManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GpuProgramManager Class Reference
Core » Resources

This ResourceManager manages GPU shader programs. More...

`#include <OgreGpuProgramManager.h>`

Inheritance diagram for Ogre::GpuProgramManager:
[legend]

## Public Types
typedef MemoryDataStreamPtr | Microcode
typedef std::map< String, GpuSharedParametersPtr > | SharedParametersMap
typedef std::set< String > | SyntaxCodes
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef std::map< ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef std::unordered_map< String, ResourcePtr > | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef std::unordered_map< String, ResourceMap > | ResourceWithGroupMap

## Public Member Functions
| GpuProgramManager ()
virtual | ~GpuProgramManager ()
void | addFactory (GpuProgramFactory *factory)
| Add a new factory object for programs of a given language.
void | addMicrocodeToCache (uint32 id, const Microcode &microcode)
| Adds a microcode for a program to the microcode cache.
GpuProgramPtr | create (const String &name, const String &group, GpuProgramType gptype, const String &language, bool isManual=false, ManualResourceLoader *loader=0)
| General create method, using specific create parameters instead of name / value pairs.
virtual GpuProgramPtr | createProgram (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Create a new, unloaded GpuProgram from a file of assembly.
GpuProgramPtr | createProgram (const String &name, const String &groupName, const String &language, GpuProgramType gptype)
| Create a new, unloaded GpuProgram.
virtual GpuProgramPtr | createProgramFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Create a GPU program from a string of assembly code.
virtual GpuSharedParametersPtr | createSharedParameters (const String &name)
| Create a new set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.
virtual const SharedParametersMap & | getAvailableSharedParameters () const
| Get (const) access to the available shared parameter sets.
GpuProgramPtr | getByName (const String &name, const String &group, bool preferHighLevelPrograms) const
GpuProgramPtr | getByName (const String &name, const String &group=RGN_DEFAULT) const
| Get a GPU Program by name.
const Microcode & | getMicrocodeFromCache (uint32 id) const
| Returns a microcode for a program from the microcode cache.
bool | getSaveMicrocodesToCache () const
| Get if the microcode of a shader should be saved to a cache.
virtual GpuSharedParametersPtr | getSharedParameters (const String &name) const
| Retrieve a set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.
bool | isCacheDirty (void) const
| Returns true if the microcodecache changed during the run.
bool | isLanguageSupported (const String &lang) const
| Returns whether a given high-level language (e.g.
bool | isMicrocodeAvailableInCache (uint32 id) const
| Check if a microcode is available for a program in the microcode cache.
virtual GpuProgramPtr | load (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a file.
virtual GpuProgramPtr | loadFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a string.
void | loadMicrocodeCache (const DataStreamPtr &stream)
| Loads the microcode cache from disk.
void | removeFactory (GpuProgramFactory *factory)
| Remove a factory object for programs of a given language.
void | removeMicrocodeFromCache (uint32 id)
| Removes a microcode for a program from the microcode cache.
void | saveMicrocodeCache (const DataStreamPtr &stream) const
| Saves the microcode cache to disk.
void | setSaveMicrocodesToCache (bool val)
| Set if the microcode of a shader should be saved to a cache.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
virtual | ~ResourceManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle) const
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder (void) const override
| Gets the loading order for scripts of this type.
size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns (void) const override
| Gets the file patterns which should be used to find scripts for this class.
bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse a script file.
ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
void | remove (const ResourcePtr &r)
| Remove a single resource.
void | remove (const String &name, const String &group=RGN_DEFAULT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | remove (ResourceHandle handle)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | removeAll (void)
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
bool | resourceExists (const String &name, const String &group=RGN_DEFAULT) const
| Returns whether the named resource exists in this manager.
bool | resourceExists (ResourceHandle handle) const
| Returns whether a resource with the given handle exists in this manager.
void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
void | unload (const String &name, const String &group=RGN_DEFAULT)
| Unloads a single resource by name.
void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< GpuProgramManager >
| ~Singleton (void)

## Static Public Member Functions
static bool | canGetCompiledShaderBuffer ()
static Microcode | createMicrocode (size_t size)
| Creates a microcode to be later added to the cache.
static GpuProgramParametersPtr | createParameters (void)
| Creates a new GpuProgramParameters instance which can be used to bind parameters to your programs.
static GpuProgramManager & | getSingleton (void)
| Get the singleton instance.
static GpuProgramManager * | getSingletonPtr (void)
| Get the singleton instance.
static const SyntaxCodes & | getSupportedSyntax (void)
| Returns the syntaxes that the RenderSystem supports.
static bool | isSyntaxSupported (const String &syntaxCode)
| Returns whether a given syntax code (e.g.
Static Public Member Functions inherited from Ogre::Singleton< GpuProgramManager >
static GpuProgramManager & | getSingleton (void)
| Get the singleton instance.
static GpuProgramManager * | getSingletonPtr (void)
| Get the singleton instance.

## Detailed Description

This ResourceManager manages GPU shader programs.

This class not only manages the programs themselves, it also manages the factory classes which allow the creation of programs using a variety of syntaxes. Plugins can be created which register themselves as program factories and as such the engine can be extended to accept virtually any kind of program provided a plugin is written.

## Member Typedef Documentation

## ◆ SyntaxCodes

typedef std::set<String> Ogre::GpuProgramManager::SyntaxCodes

## ◆ SharedParametersMap

typedef std::map<String, GpuSharedParametersPtr> Ogre::GpuProgramManager::SharedParametersMap

## ◆ Microcode

typedef MemoryDataStreamPtr Ogre::GpuProgramManager::Microcode

## Constructor & Destructor Documentation

## ◆ GpuProgramManager()

Ogre::GpuProgramManager::GpuProgramManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~GpuProgramManager()

virtual Ogre::GpuProgramManager::~GpuProgramManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getByName() [1/2]

GpuProgramPtr Ogre::GpuProgramManager::getByName | ( | const String & | name,
|  | const String & | group = RGN_DEFAULT ) const

Get a GPU Program by name.

For example, a GPU Program defined in some .program file.

See also
  GpuProgramManager::getResourceByName

References OGRE_RESOURCE_GROUP_INIT.

Referenced by getByName().

## ◆ getByName() [2/2]

GpuProgramPtr Ogre::GpuProgramManager::getByName | ( | const String & | name,
|  | const String & | group,
|  | bool | preferHighLevelPrograms ) const
| inline

Deprecated
  preferHighLevelPrograms has no effect

References getByName().

## ◆ load()

virtual GpuProgramPtr Ogre::GpuProgramManager::load | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | filename,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode )
| virtual

Loads a GPU program from a file.

This method creates a new program of the type specified as the second parameter. As with all types of ResourceManager, this class will search for the file in all resource locations it has been configured to look in.

Parameters

  name | The name of the GpuProgram
  groupName | The name of the resource group
  filename | The file to load
  gptype | The type of program to create
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ loadFromString()

virtual GpuProgramPtr Ogre::GpuProgramManager::loadFromString | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | code,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode )
| virtual

Loads a GPU program from a string.

The assembly code must be compatible with this manager - call the getSupportedSyntax method for details of the supported syntaxes

Parameters

  name | The identifying name to give this program, which can be used to retrieve this program later with getByName.
  groupName | The name of the resource group
  code | A string of assembly code which will form the program to run
  gptype | The type of program to create.
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ getSupportedSyntax()

const SyntaxCodes & Ogre::GpuProgramManager::getSupportedSyntax | ( | void |  | ) |
| static

Returns the syntaxes that the RenderSystem supports.

## ◆ isSyntaxSupported()

bool Ogre::GpuProgramManager::isSyntaxSupported | ( | const String & | syntaxCode | ) |
| static

Returns whether a given syntax code (e.g.

"glsl330", "vs_4_0", "arbvp1") is supported.

## ◆ isLanguageSupported()

bool Ogre::GpuProgramManager::isLanguageSupported | ( | const String & | lang | ) | const

Returns whether a given high-level language (e.g.

"glsl", "hlsl") is supported.

## ◆ createParameters()

GpuProgramParametersPtr Ogre::GpuProgramManager::createParameters | ( | void |  | ) |
| inlinestatic

Creates a new GpuProgramParameters instance which can be used to bind parameters to your programs.

Program parameters can be shared between multiple programs if you wish.

## ◆ createProgram() [1/2]

virtual GpuProgramPtr Ogre::GpuProgramManager::createProgram | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | filename,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode )
| virtual

Create a new, unloaded GpuProgram from a file of assembly.

Use this method in preference to the 'load' methods if you wish to define a GpuProgram, but not load it yet; useful for saving memory.

  This method creates a new program of the type specified as the second parameter. As with all types of ResourceManager, this class will search for the file in all resource locations it has been configured to look in.

Parameters

  name | The name of the program
  groupName | The name of the resource group
  filename | The file to load
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1
  gptype | The type of program to create

## ◆ createProgramFromString()

virtual GpuProgramPtr Ogre::GpuProgramManager::createProgramFromString | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | code,
|  | GpuProgramType | gptype,
|  | const String & | syntaxCode )
| virtual

Create a GPU program from a string of assembly code.

Use this method in preference to the 'load' methods if you wish to define a GpuProgram, but not load it yet; useful for saving memory.

  The assembly code must be compatible with this manager - call the getSupportedSyntax method for details of the supported syntaxes

Parameters

  name | The identifying name to give this program, which can be used to retrieve this program later with getByName.
  groupName | The name of the resource group
  code | A string of assembly code which will form the program to run
  gptype | The type of program to create.
  syntaxCode | The name of the syntax to be used for this program e.g. arbvp1, vs_1_1

## ◆ create()

GpuProgramPtr Ogre::GpuProgramManager::create | ( | const String & | name,
|  | const String & | group,
|  | GpuProgramType | gptype,
|  | const String & | language,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

General create method, using specific create parameters instead of name / value pairs.

Referenced by createProgram().

## ◆ createProgram() [2/2]

GpuProgramPtr Ogre::GpuProgramManager::createProgram | ( | const String & | name,
|  | const String & | groupName,
|  | const String & | language,
|  | GpuProgramType | gptype )
| inline

Create a new, unloaded GpuProgram.

  This method creates a new program of the type specified as the second and third parameters. You will have to call further methods on the returned program in order to define the program fully before you can load it.

Parameters

  name | The identifying name of the program
  groupName | The name of the resource group which this program is to be a member of
  language | Code of the language to use (e.g. "cg")
  gptype | The type of program to create

References create().

## ◆ createSharedParameters()

virtual GpuSharedParametersPtr Ogre::GpuProgramManager::createSharedParameters | ( | const String & | name | ) |
| virtual

Create a new set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.

Parameters

  name | The name to give the shared parameters so you can refer to them later.

## ◆ getSharedParameters()

virtual GpuSharedParametersPtr Ogre::GpuProgramManager::getSharedParameters | ( | const String & | name | ) | const
| virtual

Retrieve a set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.

## ◆ getAvailableSharedParameters()

virtual const SharedParametersMap & Ogre::GpuProgramManager::getAvailableSharedParameters | ( |  | ) | const
| virtual

Get (const) access to the available shared parameter sets.

## ◆ getSaveMicrocodesToCache()

bool Ogre::GpuProgramManager::getSaveMicrocodesToCache | ( |  | ) | const

Get if the microcode of a shader should be saved to a cache.

## ◆ setSaveMicrocodesToCache()

void Ogre::GpuProgramManager::setSaveMicrocodesToCache | ( | bool | val | ) |

Set if the microcode of a shader should be saved to a cache.

## ◆ isCacheDirty()

bool Ogre::GpuProgramManager::isCacheDirty | ( | void |  | ) | const

Returns true if the microcodecache changed during the run.

## ◆ canGetCompiledShaderBuffer()

bool Ogre::GpuProgramManager::canGetCompiledShaderBuffer | ( |  | ) |
| static

## ◆ isMicrocodeAvailableInCache()

bool Ogre::GpuProgramManager::isMicrocodeAvailableInCache | ( | uint32 | id | ) | const

Check if a microcode is available for a program in the microcode cache.

Parameters

  id | The id of the program.

## ◆ getMicrocodeFromCache()

const Microcode & Ogre::GpuProgramManager::getMicrocodeFromCache | ( | uint32 | id | ) | const

Returns a microcode for a program from the microcode cache.

Parameters

  id | The name of the program.

## ◆ createMicrocode()

Microcode Ogre::GpuProgramManager::createMicrocode | ( | size_t | size | ) |
| inlinestatic

Creates a microcode to be later added to the cache.

Parameters

  size | The size of the microcode in bytes

## ◆ addMicrocodeToCache()

void Ogre::GpuProgramManager::addMicrocodeToCache | ( | uint32 | id,
|  | const Microcode & | microcode )

Adds a microcode for a program to the microcode cache.

Parameters

  id | The id of the program
  microcode | the program binary

## ◆ removeMicrocodeFromCache()

void Ogre::GpuProgramManager::removeMicrocodeFromCache | ( | uint32 | id | ) |

Removes a microcode for a program from the microcode cache.

Parameters

  id | The name of the program.

## ◆ saveMicrocodeCache()

void Ogre::GpuProgramManager::saveMicrocodeCache | ( | const DataStreamPtr & | stream | ) | const

Saves the microcode cache to disk.

Parameters

  stream | The destination stream

## ◆ loadMicrocodeCache()

void Ogre::GpuProgramManager::loadMicrocodeCache | ( | const DataStreamPtr & | stream | ) |

Loads the microcode cache from disk.

Parameters

  stream | The source stream

## ◆ addFactory()

void Ogre::GpuProgramManager::addFactory | ( | GpuProgramFactory * | factory | ) |

Add a new factory object for programs of a given language.

## ◆ removeFactory()

void Ogre::GpuProgramManager::removeFactory | ( | GpuProgramFactory * | factory | ) |

Remove a factory object for programs of a given language.

## ◆ getSingleton()

GpuProgramManager & Ogre::GpuProgramManager::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

References GpuProgramManager().

## ◆ getSingletonPtr()

GpuProgramManager * Ogre::GpuProgramManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

References GpuProgramManager().

The documentation for this class was generated from the following file:

- OgreGpuProgramManager.h